#!/usr/bin/python

import Ai
import Attack
import BaseAI
import EnemyShips
import Escort
import Wait
import MineAI
import TargetAI
import Patrol

import gutil
import pygame
import os
from pygame.locals import *
from OpenGL.GL import *

from Image import Image
from Text import Text
from Engine import Engine

import globals
from globals import *
from Intro import Intro
from Config import *

ipshell = None
try:
    from IPython.Shell import IPShellEmbed
    ipshell = IPShellEmbed() 
except:
    pass




def main():
    pygame.init()
    pygame.display.set_caption("Shadow Runner 2210")
    icon = pygame.image.load(os.path.join('data', 'heroship.png'))
    pygame.display.set_icon(icon)

    gutil.initializeDisplay(DWIDTH, DHEIGHT)
    pygame.mixer.init()
    

    globals.config_filename = os.path.join('data', 'config.cfg')
    if os.path.exists(globals.config_filename):
        globals.config = load(globals.config_filename)
        globals.config['max_level'] = int(globals.config['max_level'])
    else:
        globals.config['max_level'] = 0
        save(globals.config, globals.config_filename)

    engine = Engine()
    intro = Intro(engine.loader)
    engine.level.initLevel()
    
    state = 1
    #0 = starting
    #1 = intro
    #2 = engine

    done = False


    while not done:
        glClear(GL_COLOR_BUFFER_BIT)
        
        if state == 2:
            engine.update()
        elif state == 1:
            intro.update()
        else:
            print "This should never happen."
            
        pygame.display.flip()

        eventlist = pygame.event.get()
        for event in eventlist:
            if event.type == QUIT:
                done = True
            elif event.type == KEYDOWN and event.key == K_BACKQUOTE:
                if ipshell:
                    ipshell()
                    try:
                        engine.clock.tick()
                    except:
                        pass
            elif event.type == KEYDOWN or event.type == KEYUP:
                if state == 2:
                    if event.type == KEYDOWN and event.key == K_ESCAPE:
                        state = 1
                        intro.make_level_list()
                        intro.shown = intro.main
                        intro.main.position = 0
                    else:
                        engine.handleKeyboardEvent(event)
                elif state == 1:
                    state, value = intro.handleKey(event.type, event.key)
                    if state < 1:
                        done = True
                    elif state == 2:
                        engine.loader.setLevel(value)
                        engine.level = engine.loader.getLevel()
                        engine.level.initLevel()
                        state = 2


if __name__ == '__main__':
    main()
